#include "classes.h"

D2CBuffer::D2CBuffer() {

	setBufferPointer(NULL);

	clearBuffer(256);

}

D2CBuffer::D2CBuffer(I32 i32Arg) {

	setBufferPointer(NULL);

	clearBuffer(i32Arg);

}

D2CBuffer::~D2CBuffer() {

	deleteBuffer();

}

CSTR D2CBuffer::getCSTR() { return (CSTR)getBufferPointer(); }

BUF D2CBuffer::getBuffer() const { return getBufferPointer(); }

bool D2CBuffer::clearBuffer(I32 i32Arg) {

	if (i32Arg<0)
		return false;

	deleteBuffer();

	if (i32Arg==0)
		return true;

	setBufferPointer(new UI8[i32Arg+1]);

	if (getBufferPointer()==NULL)
		return false;

	ZeroMemory(getBufferPointer(),i32Arg+1);

	setBufferSize(i32Arg);

	return true;

}

bool D2CBuffer::resizeBuffer(I32 i32Arg) {

	if (i32Arg<0)
		return false;

	I32 i32Cpy=i32Arg;

	if (i32Cpy>getBufferSize())
		i32Cpy=getBufferSize();

	BUF bfTmp=new UI8[i32Cpy];
	memcpy(bfTmp,getBufferPointer(),i32Cpy);

	deleteBuffer();

	setBufferPointer(new UI8[i32Arg+1]);

	if (getBufferPointer()==NULL) {

		delete [] bfTmp;
		return false;

	}

	memcpy(getBufferPointer(),bfTmp,i32Cpy);
	setBufferSize(i32Arg);

	if (i32Cpy<getBufferSize())
		ZeroMemory(getBufferPointer()+i32Cpy,getBufferSize()-i32Cpy);

	writeBufferByte(getBufferSize(),0);

	return true;

}

bool D2CBuffer::appendBufferByte(UI8 u8Arg) {

	if (!resizeBuffer(getBufferSize()+1))
		return false;

	writeBufferByte(getBufferSize()-1,u8Arg);

	return true;

}

bool D2CBuffer::appendBuffer(const BUF bfArg,I32 i32Arg) {

	if (i32Arg<1)
		return false;

	I32 i32Index=getBufferSize();

	if (!resizeBuffer(getBufferSize()+i32Arg))
		return false;

	writeBuffer(i32Index,bfArg,i32Arg);

	return true;

}

bool D2CBuffer::deleteBuffer() {

	if (getBufferPointer()!=NULL)
		delete [] getBufferPointer();

	setBufferPointer(NULL);

	return true;

}
