//   Œ蒷obt@NX
//
//  2002/ 8/28 ˁ@P

#include "classes.h"
using namespace std;

D2CFixedBuffer::D2CFixedBuffer() {

	m_bfCSTR=NULL;
	setBufferPointer(NULL);
	setStreamIndex(0);

	I32 i32Size=256;

	resetBuffer(i32Size);

}

D2CFixedBuffer::D2CFixedBuffer(I32 i32Arg) {

	m_bfCSTR=NULL;
	setBufferPointer(NULL);
	setStreamIndex(0);
	setBufferSize(0);

	if (i32Arg<1)
		return;

	resetBuffer(i32Arg);

}

D2CFixedBuffer::D2CFixedBuffer(const BUF bfArg,I32 i32Arg) {

	m_bfCSTR=NULL;
	setBufferPointer(NULL);
	setStreamIndex(0);
	setBufferSize(0);

	if (bfArg==NULL || i32Arg<1)
		return;

	setBufferPointer(bfArg);

	setBufferSize(i32Arg);

}

D2CFixedBuffer::D2CFixedBuffer(const D2IBufferReader *pbrArg) {

	m_bfCSTR=NULL;
	setBufferPointer(NULL);
	setStreamIndex(0);
	setBufferSize(0);

	if (pbrArg==NULL || pbrArg->getBufferSize()<1)
		return;

	setBufferPointer(new UI8[pbrArg->getBufferSize()]);

	if (getBufferPointer()==NULL)
		return;
	
	setBufferSize(pbrArg->getBufferSize());

	BUF bfTmp=pbrArg->copyBuffer();

	writeBuffer(0,bfTmp,getBufferSize());

	delete [] bfTmp;

}

D2CFixedBuffer::D2CFixedBuffer(const D2CFixedBuffer& bArg) {

	m_bfCSTR=NULL;
	setBufferPointer(NULL);
	setStreamIndex(0);
	setBufferSize(0);

	if (bArg.getBufferSize()<1)
		return;

	if (!resetBuffer(bArg.getBufferSize()))
		return;

	setStreamIndex(bArg.getStreamIndex());

	BUF bfTmp=bArg.copyBuffer();

	writeBuffer(0,bfTmp,getBufferSize());

	delete [] bfTmp;

}

D2CFixedBuffer& D2CFixedBuffer::operator=(const D2CFixedBuffer& bArg) {

	if (&bArg==this)
		return *this;

	resetBuffer(bArg.getBufferSize());

	setStreamIndex(bArg.getStreamIndex());

	if (getBufferSize()<1)
		return *this;

	BUF bfTmp=bArg.copyBuffer();

	writeBuffer(0,bfTmp,getBufferSize());

	delete [] bfTmp;

	return *this;

}

D2CFixedBuffer::~D2CFixedBuffer() {

	if (getBufferPointer()!=NULL)
		delete [] getBufferPointer();

	if (m_bfCSTR!=NULL)
		delete [] m_bfCSTR;

}

UI32 D2CFixedBuffer::getObjectType() const {

	I32 i32ID=VER_D2_0 << 24;
	i32ID+=TYPE_BUF << 16;
	i32ID+=ENCODE_NONE;

	return i32ID;

}

UI8 D2CFixedBuffer::getObjectVersion() const { return VER_D2_0; }
UI8 D2CFixedBuffer::getDataType() const { return TYPE_BUF; }
UI16 D2CFixedBuffer::getEncoding() const { return ENCODE_NONE; }

void * D2CFixedBuffer::getInterface(UI32 u32Arg) {

	switch(u32Arg) {

	case ID_D2IObject:
		return (D2IObject *)this;

	case ID_D2IStreamReader:
		return (D2IStreamReader *)this;

	case ID_D2IStreamWriter:
		return (D2IStreamWriter *)this;

	case ID_D2IStream:
		return (D2IStream *)this;

	case ID_D2IBufferReader:
		return (D2IBufferReader *)this;

	case ID_D2IBufferWriter:
		return (D2IBufferWriter *)this;

	case ID_D2IFixedBuffer:
		return (D2IFixedBuffer *)this;

	}

	return NULL;

}

CSTR D2CFixedBuffer::getCSTR() {

	if (m_bfCSTR!=NULL) {

		delete [] m_bfCSTR;
		m_bfCSTR=NULL;

	}

	if (getBufferSize()<1)
		return NULL;

	m_bfCSTR=new UI8[getBufferSize()+1];

	memcpy(m_bfCSTR,getBufferPointer(),getBufferSize());
	m_bfCSTR[getBufferSize()]=0;

	return (CSTR)m_bfCSTR;

}

UI8 D2CFixedBuffer::readStreamByte() throw(out_of_range) {

	if (getStreamIndex()>=getBufferSize())
		throw out_of_range("ȃXg[CfbNX");

	return readBufferByte(getStreamIndex(1));

}

I32 D2CFixedBuffer::readStream(BUF bfArg,I32 i32Arg) {

	I32 i32Read=readBuffer(getStreamIndex(),bfArg,i32Arg);

	addStreamIndex(i32Read);

	return i32Read;

}

bool D2CFixedBuffer::writeStreamByte(UI8 u8Arg) {

	return writeBufferByte(getStreamIndex(1),u8Arg);

}

I32 D2CFixedBuffer::writeStream(const BUF bfArg,I32 i32Arg) {

	I32 i32Write=writeBuffer(getStreamIndex(),bfArg,i32Arg);

	addStreamIndex(i32Write);

	return i32Write;

}

I32 D2CFixedBuffer::getBufferSize() const { return m_i32BufferSize; }

BUF D2CFixedBuffer::copyBuffer() const {

	if (getBufferSize()<1)
		return NULL;

	BUF bfTmp=new UI8[getBufferSize()];

	if (bfTmp==NULL)
		return NULL;

	memcpy(bfTmp,getBufferPointer(),getBufferSize());

	return bfTmp;

}

UI8 D2CFixedBuffer::readBufferByte(I32 i32Arg) const throw(out_of_range) {

	if (i32Arg<0 || i32Arg>=getBufferSize())
		throw out_of_range("ȃCfbNX");

	return getBufferPointer()[i32Arg];

}

I32 D2CFixedBuffer::readBuffer(I32 i32Arg1,BUF bfArg,I32 i32Arg2) const {

	if (i32Arg1<0 || i32Arg1>=getBufferSize() || bfArg==NULL || i32Arg2<1)
		return 0;

	I32 i32Read=i32Arg2;

	if (i32Arg1+i32Read>getBufferSize())
		i32Read=getBufferSize()-i32Arg1;
	
	memcpy(bfArg,getBufferPointer()+i32Arg1,i32Read);

	return i32Read;

}

bool D2CFixedBuffer::equalBuffer(const BUF bfArg,I32 i32Arg) const {

	if (i32Arg!=getBufferSize())
		return false;

	for (int i=0;i<getBufferSize();i++)
		if (bfArg[i]!=readBufferByte(i))
			return false;

	return true;

}

bool D2CFixedBuffer::equalBuffer(const D2IBufferReader *pbrArg) const {

	if (pbrArg==NULL)
		return false;

	if (pbrArg->getBufferSize()!=getBufferSize())
		return false;

	for (int i=0;i<getBufferSize();i++)
		if (pbrArg->readBufferByte(i)!=readBufferByte(i))
			return false;

	return true;

}

bool D2CFixedBuffer::writeBufferByte(I32 i32Arg,UI8 u8Arg) {

	if (i32Arg<0 || i32Arg>=getBufferSize())
		return false;

	getBufferPointer()[i32Arg]=u8Arg;

	return true;

}

I32 D2CFixedBuffer::writeBuffer(I32 i32Arg1,const BUF bfArg,I32 i32Arg2) {

	if (i32Arg1<0 || i32Arg1>=getBufferSize() || bfArg==NULL || i32Arg2<1)
		return 0;

	I32 i32Write=i32Arg2;

	if (i32Arg1+i32Write>getBufferSize())
		i32Write=getBufferSize()-i32Arg1;
	
	memcpy(getBufferPointer()+i32Arg1,bfArg,i32Write);

	return i32Write;

}

bool D2CFixedBuffer::fillBuffer(I32 i32Arg1,UI8 u8Arg,I32 i32Arg2) {

	if (i32Arg1<0 || i32Arg1>=getBufferSize() || i32Arg2<1)
		return false;

	I32 i32Fill=i32Arg2;

	if (i32Arg1+i32Fill>getBufferSize())
		i32Fill=getBufferSize()-i32Arg1;

	FillMemory(getBufferPointer()+i32Arg1,i32Fill,u8Arg);

	return true;

}

bool D2CFixedBuffer::resetBuffer(I32 i32Arg) {

	if (i32Arg<0)
		return false;

	if (getBufferPointer()!=NULL)
		delete [] getBufferPointer();

	if (i32Arg==0) {

		setBufferSize(0);
		return true;

	}

	setBufferPointer(new UI8[i32Arg]);

	if (getBufferPointer()==NULL) {

		setBufferSize(0);
		return false;

	}

	setBufferSize(i32Arg);

	return true;

}

I32 D2CFixedBuffer::getStreamIndex() const { return m_i32StreamIndex; }

I32 D2CFixedBuffer::getStreamIndex(I32 i32Arg) {

	I32 i32Index=getStreamIndex();

	addStreamIndex(i32Arg);

	return i32Index;

}

bool D2CFixedBuffer::addStreamIndex(I32 i32Arg) {

	m_i32StreamIndex+=i32Arg;

	return true;

}

bool D2CFixedBuffer::setStreamIndex(I32 i32Arg) {

	m_i32StreamIndex=i32Arg;

	return true;

}

bool D2CFixedBuffer::setBufferSize(I32 i32Arg) {

	m_i32BufferSize=i32Arg;

	return true;

}

BUF D2CFixedBuffer::getBufferPointer() const { return m_bfBuffer; }

bool D2CFixedBuffer::setBufferPointer(BUF bfArg) {

	m_bfBuffer=bfArg;

	return true;

}
